image: ghcr.io/cirruslabs/flutter
stages:
  - analyzeCode
  - flutterTestBuild
  - build
  - notify

variables:
  SLACK_WEBHOOK: "https://gitlabrunnern-n471242.slack.com/archives/C07M2TPG8BV" # replace with your webhook slack url

flutter_analyze:
  stage: analyzeCode
  script:
    - flutter clean
    - flutter pub get
    # - dart fix --dry-run
    - dart fix --apply
    - flutter analyze
  tags:
    - flutter-deine-android

flutter_test_build:
  stage: flutterTestBuild
  script:
    - flutter clean
    - flutter pub get
    - flutter build apk --release --target-platform=android-arm64
  artifacts:
    paths:
      - build/artifacts/
  # only:
  #   refs:
  #     - merge_requests
  #   variables:
  #     - $CI_COMMIT_MESSAGE =~ /ctb/i
  tags:
    - flutter-deine-android
android:
  stage: build
  script:
    - flutter build apk --release
    - flutter build appbundle --release
    # - sudo bundle install
    # - cd android && bundle exec fastlane move_files
  artifacts:
    paths:
      - build/artifacts/
  tags:
    - flutter-deine-android

notify:
  stage: notify
  script:
    - >
      if [ "$CI_COMMIT_REF_NAME" == "main" ]; then
        status="Success"
        color="#36a64f"
      else
        status="Failure"
        color="#d50200"
      fi
    - >
      curl -X POST -H "Content-type: application/json" --data
      '{
        "text": "Flutter Build '"$status"' for branch: '"$CI_COMMIT_REF_NAME"'",
        "attachments": [
          {"text": "Build '"$status"'", "color": "'$color'"}
        ]
      }' $SLACK_WEBHOOK
  only:
    - main # Adjust this to the branch you want to trigger notifications for

# image: ghcr.io/cirruslabs/flutter
# stages:
#   - lints
#   - tests
#   - build
#   - deploy
# lints:
#   stage: lints
#   before_script:
#     - bash reconfigure.sh
#   script:
#     - flutter analyze
#   tags:
#     - flutter-deine-android
# # unit tests:
# #   stage: tests
# #   script:
# #     - flutter test --coverage ./lib
# #     - lcov -r coverage/lcov.info '*/__test*__/*' -o coverage/lcov_cleaned.info
# #     - genhtml coverage/lcov_cleaned.info --output=coverage
# #   tags:
# #     - flutter-deine-android
# #   artifacts:
# #     paths:
# #       - coverage
# android:
#   stage: build
#   script:
#     # - flutter build apk --release --build-number ${CI_JOB_ID:0:8}
#     # - flutter build appbundle --release --build-number ${CI_JOB_ID:0:8}
#     - flutter build apk --release
#     - flutter build appbundle --release
#     - sudo bundle install
#     # - cd android && bundle exec fastlane move_files
#   artifacts:
#     paths:
#       - build/artifacts/
#   tags:
#     - flutter-deine-android

# playstore:
#   stage: deploy
#   dependencies:
#     - android
#   script:
#     - cd android && bundle exec fastlane playstore_internal_release
#   tags:
#     - flutter-deine-android
